src/car_collection/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

from . import views

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('accounts/', include('django.contrib.auth.urls')),
    path('admin/', admin.site.urls),
    path('brands/', views.AllBrandsView.as_view(), name='brand_all'),
    path('brand/new/', views.NewBrandView.as_view(), name='brand_new'),
    path('brand/<str:pk>/', views.BrandView.as_view(), name='brand'),
    path('brand/<str:pk>/edit/', views.EditBrandView.as_view(), name='brand_edit'),
    path('brand/<str:pk>/delete/', views.DeleteBrandView.as_view(), name='brand_delete'),
    path('carmodels/', views.AllCarModelsView.as_view(), name='carmodel_all'),
    path('carmodel/new/', views.NewCarModelView.as_view(), name='carmodel_new'),
    path('carmodel/<str:pk>/', views.CarModelView.as_view(), name='carmodel'),
    path('carmodel/<str:pk>/edit/', views.EditCarModelView.as_view(), name='carmodel_edit'),
    path('carmodel/<str:pk>/delete/', views.DeleteCarModelView.as_view(), name='carmodel_delete'),
    path('mycars/', views.MyCarsView.as_view(), name='my_cars'),
    path('mycars/add/', views.MyCarsAddView.as_view(), name='my_cars_add_cars'),
    path('mycars/add_random/', views.MyCarsAddRandomView.as_view(), name='my_cars_add_random_car'),
    path('mycars/add_multirandom/', views.MyCarsAddMultiRandomView.as_view(), name='my_cars_add_multi_random_car'),
    path('mycars/<str:pk>/', views.MyCarsDetailView.as_view(), name='my_cars_detail'),
    path('mycars/<str:pk>/delete/', views.MyCarsDeleteView.as_view(), name='my_cars_delete'),
    path('mycars/<str:pk>/give/', views.MyCarsGiveView.as_view(), name='my_cars_give'),
    path('mycars/<str:pk>/sell/', views.MyCarsSellView.as_view(), name='my_cars_sell'),
    path('settings/edit', views.EditSettingsView.as_view(), name='edit_settings'),
    path('add_money', views.AddMoneyView.as_view(), name='add_money'),
    path('give_money', views.GiveMoneyView.as_view(), name='give_money'),
]

if settings.DEBUG:
     urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/car_collection/models.py
"""
this module contains all Models
"""

import uuid

from django.conf import settings
from django.contrib.auth.models import User
from django.db import models
from django.db.models.signals import post_save
from django.dispatch import receiver

from . import settings as app_settings


class Brand(models.Model):
    """ a car brand """

    name = models.CharField(max_length=512)
    logo = models.ImageField(upload_to='logo', blank=True)

    def __str__(self):
        return self.name

class CarModel(models.Model):
    """ a car """

    class Rank(models.TextChoices):
        E = 'E'
        D = 'D'
        C = 'C'
        B = 'B'
        A = 'A'
        S = 'S'
        SS = 'SS'
        SSS = 'SSS'
        Z = 'Z'
        ZZ = 'ZZ'
        ZZZ = 'ZZZ'
        Uz = 'Uz'

        @classmethod
        def value_from_label(cls, label:str):
            index = 0
            for l in cls.labels:
                if label == l:
                    return cls.values[index]
                index += 1
            raise ValueError()

    name = models.CharField(max_length=512)
    brand = models.ForeignKey(Brand, on_delete=models.CASCADE)
    picture = models.ImageField(upload_to='cars')
    description = models.TextField(default="", blank=True)
    # description details
    max_speed = models.CharField(max_length=16, default="", blank=True)
    acceleration = models.CharField(max_length=16, default="", blank=True)
    horse_power = models.CharField(max_length=16, default="", blank=True)
    tork = models.CharField(max_length=16, default="", blank=True)
    weight = models.CharField(max_length=16, default="", blank=True)
    motor = models.CharField(max_length=16, default="", blank=True)
    #
    event = models.TextField(default="", blank=True)
    year = models.IntegerField(default=2000)
    rank = models.CharField(
        max_length=3, choices=Rank.choices, default=Rank.A)
    price = models.IntegerField(default=0)


    def __str__(self):
        return self.name

    @property
    def rank_url(self):
        return f"car_collection/rangs/Rang_{self.rank}.webp"

class UserCollection(models.Model):
    """ all the cars owned by a user """

    user = models.OneToOneField(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name='collection', null=True)
    money = models.FloatField(default=100)

    def __str__(self):
        return "Collection de "+self.user.username

class OwnedCar(models.Model):
    """ a car owned by someone"""

    model = models.ForeignKey(CarModel, on_delete=models.CASCADE)
    collection = models.ForeignKey(UserCollection, on_delete=models.CASCADE, null=True)
    number = models.IntegerField(default=0)

class UserSettings(models.Model):
    """ app settings per user """

    user = models.OneToOneField(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name='settings', null=True)
    cars_per_page = models.IntegerField(default=10)

@receiver(post_save, sender=settings.AUTH_USER_MODEL)
def create_user_settings(sender, instance, created, **kwargs):
    """" signal receiver to create a UserSettings object upon User creation """

    if created:
        UserSettings.objects.create(user=instance)
        UserCollection.objects.create(user=instance)


@receiver(post_save, sender=settings.AUTH_USER_MODEL)
def save_user_settings(sender, instance, **kwargs):
    """ signal to save the UserSettings object upon User save """

    instance.settings.save()
    instance.collection.save()

src/car_collection/forms.py
from django import forms

from car_collection.models import CarModel, UserCollection

class MyCarsAddForm(forms.Form):
    selected_cars = forms.ModelMultipleChoiceField(queryset=CarModel.objects.all())

class MyCarsDeleteForm(forms.Form):
    number = forms.IntegerField(min_value=0)
    def __init__(self, *args, **kwargs):
        # Pop the number argument, as the parent form doesn't know about it!
        number = kwargs.pop("number")
        super().__init__(*args, **kwargs)
        self.fields['number'].widget.attrs['max'] = number

class MyCarsSellForm(forms.Form):
    number = forms.IntegerField(min_value=0)
    def __init__(self, *args, **kwargs):
        # Pop the number argument, as the parent form doesn't know about it!
        number = kwargs.pop("number")
        super().__init__(*args, **kwargs)
        self.fields['number'].widget.attrs['max'] = number

class MyCarsGiveForm(forms.Form):
    selected_user = forms.ModelChoiceField(queryset=UserCollection.objects.all())
    number = forms.IntegerField(min_value=0)
    def __init__(self, *args, **kwargs):
        # Pop the number argument, as the parent form doesn't know about it!
        number = kwargs.pop("number")
        super().__init__(*args, **kwargs)
        self.fields['number'].widget.attrs['max'] = number

class MoneyGiveForm(forms.Form):
    selected_user = forms.ModelChoiceField(queryset=UserCollection.objects.all())
    amount = forms.IntegerField(min_value=0)

src/car_collection/views/brand.py
"""
this module provides Collection related views
"""

import datetime

from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse, reverse_lazy
from django.views.generic import CreateView, UpdateView, DeleteView, DetailView, ListView
from django.views.generic.list import MultipleObjectMixin

from django_q.tasks import async_task
from django_q.models import Schedule

from car_collection.models import Brand

# pylint: disable=R0901 # too many ancestor

class AllBrandsView(LoginRequiredMixin, ListView):
    """ this view displays all collections """
    template_name = 'car_collection/brand_all.html'

    def get(self, request, *args, **kwargs):
        self.user = request.user
        self.paginate_by = request.user.settings.cars_per_page
        return super().get(request, args, kwargs)

    def get_queryset(self):
        return Brand.objects.all().order_by('name')

class BrandView(LoginRequiredMixin, DetailView, MultipleObjectMixin):
    """ this view provides details about a brand """
    template_name = 'car_collection/brand.html'
    context_object_name = 'brand'
    model = Brand

    def get(self, request, *args, **kwargs):
        self.user = request.user
        self.paginate_by = request.user.settings.cars_per_page
        return super().get(request, args, kwargs)

    def get_context_data(self, **kwargs):
        object_list = self.object.carmodel_set.order_by('name')
        context = super().get_context_data(object_list=object_list, **kwargs)
        return context

class NewBrandView(LoginRequiredMixin, CreateView):
    """ create a new brand """
    model = Brand
    template_name = 'car_collection/brand_new.html'
    fields = ('name', 'logo')
    success_url = reverse_lazy('brand_all')

class EditBrandView(LoginRequiredMixin, UpdateView):
    """ edit a collebrandction """
    model = Brand
    template_name = 'car_collection/brand_edit.html'
    fields = ('name', 'logo')
    success_url = reverse_lazy('brand_all')

    def get(self, request, *args, **kwargs):
        self.user = request.user
        return super().get(request, *args, **kwargs)

class DeleteBrandView(LoginRequiredMixin, DeleteView):
    """ this view requests the deletion of an brand """
    model = Brand
    template_name = 'car_collection/brand_delete.html'
    success_url = reverse_lazy('brand_all')

src/car_collection/views/carmodel.py
"""
this module contains Carmodel related views
"""
import os

from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponse, Http404
from django.shortcuts import get_object_or_404
from django.urls import reverse, reverse_lazy
from django.views import View
from django.views.generic import CreateView, DetailView, DeleteView, UpdateView, ListView
from django.views.generic.list import MultipleObjectMixin
from django.shortcuts import render

from car_collection.models import CarModel, Brand, OwnedCar

# pylint: disable=R0901 # too many ancestor

class AllCarModelsView(LoginRequiredMixin, ListView):
    """ this view displays all car models """

    def get_template_names(self):
        return ['car_collection/carmodel_all_'+self.view+'.html']

    def get_queryset(self):
        if self.order_by is None:
            return CarModel.objects.all().order_by('brand__name', 'name')
        elif self.order_by in ["name" , "-name"]:
            return CarModel.objects.all().order_by('brand__name', self.order_by)
        else:
            return CarModel.objects.all().order_by(self.order_by)

    def get(self, request, *args, **kwargs):
        self.user = request.user
        self.order_by = request.GET.get('order')
        self.view = request.GET.get('view', 'list')
        if self.view == 'list':
            self.paginate_by = request.user.settings.cars_per_page
        return super().get(request, args, kwargs)

class NewCarModelView(LoginRequiredMixin, CreateView):
    """ create a new car """
    model = CarModel
    template_name = 'car_collection/carmodel_new.html'
    fields = ('name', 'brand', 'picture', 'year', 'description', 'max_speed', 'acceleration', 'horse_power', 'tork', 'weight', 'motor', 'event', 'rank', 'price')

    def get_initial(self):
        """ override get_initial to get default values from GET """
        brand_id = self.request.GET.get('brand', '')
        return {
          'brand': brand_id,
        }

    def get_success_url(self):
        """ override get_success_url() to return to the parent brand page """
        return reverse_lazy('brand', args=(self.object.brand.pk,))

class CarModelView(LoginRequiredMixin, DetailView, MultipleObjectMixin):
    """ this view provides details about the Car provided by its pk """
    template_name = 'car_collection/carmodel_detail.html'
    context_object_name = 'carmodel'
    model = CarModel

    def get(self, request, *args, **kwargs):
        self.user = request.user
        return super().get(request, args, kwargs)

    def get_context_data(self, **kwargs):
        object_list = CarModel.objects.all().order_by('name')
        context = super().get_context_data(object_list=object_list, **kwargs)

        # count the number of owned_car from user.collection and store it into the context
        owned_car = self.user.collection.ownedcar_set.filter(model=self.object).first()
        if owned_car is not None:
            context['owned_count'] = owned_car.number
        else:
            context['owned_count'] = 0
        # count the number of owned_car from every own
        context['total_owned_count'] = 0
        for item in OwnedCar.objects.filter(model=self.object):
            context['total_owned_count'] = context['total_owned_count'] + item.number

        return context

class EditCarModelView(LoginRequiredMixin, UpdateView):
    """ edit a Car """
    model = CarModel
    template_name = 'car_collection/carmodel_edit.html'
    success_url = reverse_lazy('carmodel_all')
    fields = ('name', 'brand', 'picture', 'year', 'description', 'max_speed', 'acceleration', 'horse_power', 'tork', 'weight', 'motor', 'event', 'rank', 'price')

    def get(self, request, *args, **kwargs):
        self.user = request.user
        return super().get(request, *args, **kwargs)

class DeleteCarModelView(LoginRequiredMixin, DeleteView):
    """ this view requests the deletion of a car """
    model = CarModel
    template_name = 'car_collection/carmodel_delete.html'

    def get_success_url(self):
        """ override get_success_url() to return to the collection page """
        return reverse_lazy('brand', args=(self.object.brand.pk,))

src/car_collection/views/index.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponseRedirect
from django.urls import reverse_lazy
from django.views.generic import View, FormView

from car_collection.forms import MoneyGiveForm
from car_collection.views import AllBrandsView

# pylint: disable=R0901 # too many ancestor

class IndexView(AllBrandsView):
    pass

class AddMoneyView(LoginRequiredMixin, View):
    """ simple view to add a small amount of money """

    def get(self, request, *args, **kwargs):
        self.user = request.user
        self.user.collection.money += 50
        self.user.collection.save()
        return HttpResponseRedirect(reverse_lazy('index'))

class GiveMoneyView(LoginRequiredMixin, FormView):
    """ view to give an amount of money to another player """
    template_name = 'car_collection/money_give.html'
    form_class = MoneyGiveForm

    def get(self, request, *args, **kwargs):
        self.user = request.user
        return super().get(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        self.user = request.user
        self.next = request.POST.get('next', '/')
        return super().post(request, *args, **kwargs)

    def form_valid(self, form):

        amount = form.cleaned_data["amount"]
        selected_user = form.cleaned_data["selected_user"]

        # check it is not the same user and we have enough money
        if self.user.id != selected_user.id and \
                self.user.collection.money >= amount:
            self.user.collection.money -= amount
            self.user.collection.save()

            selected_user.money += amount
            selected_user.save()

        return HttpResponseRedirect(self.next)

src/car_collection/views/settings.py
"""
this module contains settings related views
"""

from django.http import HttpResponseRedirect
from django.views.generic import UpdateView
from django.urls import reverse_lazy

from car_collection.models import UserSettings

class EditSettingsView(UpdateView):
    """ this is the update view for Settings """
    model = UserSettings
    fields = ['cars_per_page', ]
    template_name = 'car_collection/edit_settings.html'
    success_url = reverse_lazy('index')

    def get(self, request, *args, **kwargs):
        """ override get() to catch request.user """
        self.user = request.user
        return super().get(request, args, kwargs)

    def post(self, request, *args, **kwargs):
        """ override post() to handle the cancel button """
        if "cancel" in request.POST:
            return HttpResponseRedirect(self.success_url)
        self.user = request.user
        return super().post(request, *args, **kwargs)

    def get_object(self, queryset=None):
        try:
            if self.user.settings is not None:
                return self.user.settings
        except UserSettings.DoesNotExist:
            pass
        new = UserSettings.objects.create()
        self.user.settings = new
        return self.user.settings

    def get_success_url(self):
        """ override get_success_url() to return to the all repositories page """
        return reverse_lazy('index')

src/car_collection/templates/car_collection/brand.html
{% extends "car_collection/__base.html" %}

{% load static %}

{% block actions %}
<div class="btn-group px-1">
  <button type="button" class="btn btn-secondary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">{{ brand.name }}</button>
  <ul class="dropdown-menu dropdown-menu-dark" aria-labelledby="navbarDropdown">
      <li><a class="dropdown-item" href="{% url 'brand_edit' brand.id %}">Editer</a></li>
      <li><a class="dropdown-item" href="{% url 'brand_delete' brand.id %}">Supprimer</a></li>
      <div class="dropdown-divider"></div>
      <li><a class="dropdown-item" href="{% url 'my_cars_add_cars' %}?brand={{ brand.id }}">Ajouter une voiture</a></li>
  </ul>
</div>
{% endblock %}

{% block content %}
<div class="card shadow">
  <div class="card-header">
    {{ brand.name }} ({{ page_obj.paginator.count }} voitures)
  </div>
  <div class="card-body">
    <table class="table">
      <thead class="thead-light">
        <tr>
          <th scope="col">Nom</th>
          <th scope="col">Image</th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
      <tbody>
        {% for carmodel in object_list %}
        <tr>
          <td>
            <a class="" href="{% url 'carmodel' carmodel.id %}">
              {{ carmodel.name }}
            </a>
          </td>
          <td><img src="{{ carmodel.picture.url }}" height="60"/></td>
          <td>
            <a type="button" class="btn btn-warning btn-sm" href="{% url 'carmodel_edit' carmodel.id %}">
              <img class="img-fluid" src="{% static 'car_collection/adwaita_scalable/actions/document-edit-symbolic.svg' %}" title="Edit"/>
            </a>
            <a type="button" class="btn btn-warning btn-sm" href="{% url 'carmodel_delete' carmodel.id %}">
              <img class="img-fluid" src="{% static 'car_collection/adwaita_scalable/places/user-trash-symbolic.svg' %}" title="Delete"/>
            </a>
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    {% if is_paginated %}
      {% include "car_collection/_pagination.html" %}
    {% endif %}
  </div>
</div>
{% endblock %}

src/car_collection/templates/car_collection/brand_delete.html
{% extends "car_collection/__base.html" %}
{% block content %}
<form action="{% url 'brand_delete' brand.id %}" method="POST">
    {% csrf_token %}
    <p>Are you sure you want to delete {{ object.name }} ?</p>
    <input type="submit" name="action" value="Confirmer" class="btn btn-primary" />
    <a href="{{ view.get_success_url }}" class="btn btn-warning">Annuler</a>
</form>
{% endblock %}

src/car_collection/templates/car_collection/brand_edit.html
{% extends "car_collection/__base.html" %}
{% block content %}
<div class="row justify-content-center">
    <div class="col-lg-5">
        <div class="card shadow-lg border-0 rounded-lg mt-5">
            <div class="card-header"><h3 class="text-center font-weight-light my-4">Editer la marque</h3></div>
            <div class="card-body">
                <form action="{% url 'brand_edit' brand.id %}" method="POST" enctype="multipart/form-data">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <div class="text-center">
                        <input type="submit" name="action" value="Confirm" class="btn btn-primary" />
                        <a href="{{ view.get_success_url }}" class="btn btn-warning">Annuler</a>
                    </div>
                  </form>
            </div>
        </div>
    </div>
</div>
<script>
    document.getElementById("id_name").classList.add("form-control");
</script>
{% endblock %}

src/car_collection/templates/car_collection/carmodel_all_list.html
{% extends "car_collection/__base.html" %}

{% load static %}

{% block content %}
<div class="card shadow">
  <div class="card-header">
    Toutes les voitures ({{ page_obj.paginator.count }} voitures)
  </div>
  <div class="card-body">
    <table class="table align-middle">
      <thead class="thead-light">
        <tr>
          <th scope="col">Marque</th>
          <th scope="col">Modèle
            <a href="{% url 'carmodel_all' %}?order=-name"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-down-symbolic.svg' %}" /></a>
            <a href="{% url 'carmodel_all' %}?order=name"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-up-symbolic.svg' %}" /></a>
          </th>
          <th scope="col">Année
            <a href="{% url 'carmodel_all' %}?order=-year"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-down-symbolic.svg' %}" /></a>
            <a href="{% url 'carmodel_all' %}?order=year"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-up-symbolic.svg' %}" /></a>
          </th>
          <th scope="col">Image</th>
          <th scope="col">Rang
            <a href="{% url 'carmodel_all' %}?order=-rank"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-down-symbolic.svg' %}" /></a>
            <a href="{% url 'carmodel_all' %}?order=rank"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-up-symbolic.svg' %}" /></a>
          </th>
          <th scope="col">Prix
            <a href="{% url 'carmodel_all' %}?order=-price"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-down-symbolic.svg' %}" /></a>
            <a href="{% url 'carmodel_all' %}?order=price"><img src="{% static 'car_collection/adwaita_scalable/ui/pan-up-symbolic.svg' %}" /></a>
          </th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
      <tbody>
        {% for carmodel in carmodel_list %}
        <tr>
          <td>{{ carmodel.brand.name }}</td>
          <td>
            <a href="{% url 'carmodel' carmodel.id %}">{{ carmodel.name }}</a>
          </td>
          <td>{{ carmodel.year }}</td>
          <td><img src="{{ carmodel.picture.url }}" height="60"/></td>
          <td><img style="max-width:60px" src="{% static carmodel.rank_url %}"/></td>
          <td>{{ carmodel.price }}</td>
          <td>
            <a type="button" class="btn btn-warning btn-sm" href="{% url 'carmodel_edit' carmodel.id %}">
              <img class="img-fluid" src="{% static 'car_collection/adwaita_scalable/actions/document-edit-symbolic.svg' %}" title="Editer" />
            </a>
            <a type="button" class="btn btn-warning btn-sm" href="{% url 'carmodel_delete' carmodel.id %}">
              <img class="img-fluid" src="{% static 'car_collection/adwaita_scalable/places/user-trash-symbolic.svg' %}" title="Supprimer" />
            </a>
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    {% if is_paginated %}
      {% include "car_collection/_pagination.html" %}
    {% endif %}
  </div>
  <div class="card-footer">
    <a href="{% url 'carmodel_all' %}?view=table">Voir en table</a>
  </div>
</div>
{% endblock %}

src/car_collection/templates/car_collection/carmodel_all_table.html
{% extends "car_collection/__base.html" %}

{% load static %}

{% block content %}
<div class="container">
  {% for carmodel in carmodel_list %}
    {% if forloop.counter0|divisibleby:3 %} <div class="row text-center"> {% endif %}
      <div class="col-md-4">
        <div class="card">
          <a href="{% url 'carmodel' carmodel.id %}"><img src="{{ carmodel.picture.url }}" height="200"/></a>
          <p><a href="{% url 'brand' carmodel.brand.id %}">{{ carmodel.brand.name }}</a> <a href="{% url 'carmodel' carmodel.id %}">{{ carmodel.name }}</a></p>
        </div><!-- card -->
      </div><!-- col-md-4 -->
  {% if forloop.counter|divisibleby:3 or forloop.last %}</div><!-- row closing --><hr>{% endif %}
  {% endfor %}
</div><!-- container -->

    <a href="{% url 'carmodel_all' %}?view=list">Voir en liste</a>
{% endblock %}

src/car_collection/templates/car_collection/carmodel_delete.html
{% extends "car_collection/__base.html" %}
{% block content %}
<form action="{% url 'carmodel_delete' carmodel.id %}" method="POST">
    {% csrf_token %}
    <p>Are you sure you want to delete {{ object.name }} ?</p>
    <input type="submit" name="action" value="Confirmer" class="btn btn-primary" />
    <a href="{{ view.get_success_url }}" class="btn btn-warning">Annuler</a>
</form>
{% endblock %}

src/car_collection/templates/car_collection/index.html
{% extends "car_collection/__base.html" %}

{% load static %}

{% block content %}
<div class="row">
  <div class="col">
    <div class="card shadow">
      <div class="card-header">
        Toutes les marques
      </div>
      <div class="card-body">
        <table class="table align-middle">
          <thead class="thead-light">
            <tr>
              <th scope="col">Name</th>
              <th scope="col">Year</th>
            </tr>
          </thead>
          <tbody>
            {% for brand in brand_list %}
            <tr>
              <td>
                <a href="{% url 'brand' brand.id %}">
                  <img style="height: 25px" src="{% static 'car_collection/adwaita_scalable/apps/system-file-manager-symbolic.svg' %}" />
                  {{ brand.name }}
                </a>
              </td>
              <td>{{ brand.year }}</td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
    </div>
  </div>
</div>
{% endblock %}

src/car_collection/templates/car_collection/mycars_all_table.html
{% extends "car_collection/__base.html" %}

{% load static %}

{% block content %}
<div class="row">
  <div class="col-6">
    Mes voitures ({{ ownedcar_list | length }} voitures) ({{nb_models}} modèles différents sur {{nb_models_total}} au total)
  </div>
</div>
<div class="container">
  {% for ownedcar in ownedcar_list %}
    {% if forloop.counter0|divisibleby:3 %} <div class="row text-center"> {% endif %}
      <div class="col-md-4">
        <div class="card">
          <a href="{% url 'my_cars_detail' ownedcar.id %}"><img src="{{ ownedcar.model.picture.url }}" height="200"/></a>
          <p><a href="{% url 'brand' ownedcar.model.brand.id %}">{{ ownedcar.model.brand.name }}</a> <a href="{% url 'my_cars_detail' ownedcar.id %}">{{ ownedcar.model.name }}</a></p>
        </div><!-- card -->
      </div><!-- col-md-4 -->
  {% if forloop.counter|divisibleby:3 or forloop.last %}</div><!-- row closing --><hr>{% endif %}
  {% endfor %}
</div><!-- container -->

<div class="row">
  <div class="col-6">
    <input type="submit" name="valid" value="Confirmer" class="btn btn-primary" />
    <input type="hidden" name="view" value="table" />
  </div>
  <div class="col">
    <a href="{% url 'my_cars' %}?view=list">Voir en liste</a>
  </div>
</div>
<script type="text/javascript" >
  function toggle_all(source) {
      checkboxes = document.getElementsByClassName("cars_check");
      for (var i = 0,
          n = checkboxes.length; i < n; i++) {
          checkboxes[i].checked = source.checked;
      }
  }
</script>
{% endblock %}